import { mapValuesDeep } from "@/utils";
import { DesignComp } from "./DesignComp";
import { dataTransform } from "./versions/0.0.1";

export class DesignTemp {
  version?: string;
  _id!: string;
  title = "";
  desc = "";
  pageStyle?: any;
  content: string[] = ["root"];
  thumbnail?: string;
  compMap: { [compId: string]: DesignComp } = {};

  constructor(data?: Partial<DesignTemp>) {
    if (!data) return;
    Object.assign(this, dataTransform(data));
    // 初始化DesignComp
    Object.entries(this.compMap).forEach(([key, value]) => {
      this.compMap[key] = new DesignComp(value);
    });
    // 初始化DesignComp的pid
    Object.values(this.compMap).forEach((comp) => {
      const childIds = mapValuesDeep(
        comp.children,
        (v) => typeof v === "string",
        (v: string) => v
      );
      childIds.forEach((cid) => {
        const childComp = this.compMap[cid];
        Object.defineProperty(childComp, "pid", { value: comp.id });
      });
    });
  }
}
